; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR_SCHWER_TEMP1:
	CLI 							; Global Interrupt Disable
	call LCD_HEX_TEMP1
	ldi temp4,(LCD_E)
	ldi temp3,(LCD_R)
	STS(adr_LCD3),temp4
	STS(adr_LCD2),temp3
	call LCD_ZIFFERN_WRITE
	call LCD_DOPPELPUNKT_ON
;-------------------------------------------------------------------------------
	ldi temp9,10
ANZEIGE_ERROR_s:
	call MOTOR_BEEP
	call WAIT_500ms
	dec temp9
	brne ANZEIGE_ERROR_s
ANZEIGE_ERROR_s1:
	WDR
	rjmp ANZEIGE_ERROR_s1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR_LEICHT_TEMP1:
	call LCD_HEX_TEMP1
	ldi temp4,(LCD_E)
	ldi temp3,(LCD_R)
	STS(adr_LCD3),temp4
	STS(adr_LCD2),temp3
	call LCD_ZIFFERN_WRITE
	call LCD_DOPPELPUNKT_ON
	call WAIT_2s
	call WAIT_2s
	jmp WAIT_2s
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ZEIT_SCHALTPUNKT_TEMP1:
	push temp1
	call ANZEIGE_BARGRAPH_HEIZZEITEN
	pop temp1	

	call LCD_DOPPELPUNKT_ON
	cpi temp1,255
	brne ANZEIGE_TEXT_ZEIT_SCHALTPUNKT_w
	ldi temp,(LCD_MINUS)
	STS(adr_LCD3),temp
	STS(adr_LCD2),temp
	STS(adr_LCD1),temp
	STS(adr_LCD0),temp
	rjmp LCD_ZIFFERN_WRITE
;-------------------------------------------------------------------------------
ANZEIGE_TEXT_ZEIT_SCHALTPUNKT_w:
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	push temp2			; sichen
	clr temp2
	rcall FUNKTION_HEX_ASCII_TEMP1_2
	mov temp,temp1
	rcall LCD_UMWANDLUNG_TEMP
	STS(adr_LCD2),temp	; LCD2	
	mov temp,temp2
	rcall LCD_UMWANDLUNG_TEMP
	STS(adr_LCD3),temp	; LCD3	
	
	pop temp1			; vorher temp2 
	clr temp2
	rcall FUNKTION_HEX_ASCII_TEMP1_2
	mov temp,temp1
	rcall LCD_UMWANDLUNG_TEMP
	STS(adr_LCD0),temp	; LCD0	
	mov temp,temp2
	rcall LCD_UMWANDLUNG_TEMP
	STS(adr_LCD1),temp	; LCD1	
	jmp LCD_ZIFFERN_WRITE
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BARGRAPH_HEIZZEITEN:
	call BARGRAPH_CLEAR
	call LCD_BARGRAPH_ON

;-------------------------------------------------------------------------------
; alle Schaltpunkte anzeigen													
	LDS temp1,(adr_MOMENTAN_ON1)
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	call BARGRAPH_PUNKT_SET_TEMP1

	LDS temp1,(adr_MOMENTAN_OFF1)
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	call BARGRAPH_PUNKT_SET_TEMP1

	LDS temp1,(adr_MOMENTAN_ON2)
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	call BARGRAPH_PUNKT_SET_TEMP1

	LDS temp1,(adr_MOMENTAN_OFF2)
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	call BARGRAPH_PUNKT_SET_TEMP1

	LDS temp1,(adr_MOMENTAN_ON3)
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	call BARGRAPH_PUNKT_SET_TEMP1

	LDS temp1,(adr_MOMENTAN_OFF3)
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	call BARGRAPH_PUNKT_SET_TEMP1
;-------------------------------------------------------------------------------
;Bereiche anzeigen																
	LDS temp1,(adr_MOMENTAN_ON1)
	LDS temp2,(adr_MOMENTAN_OFF1)
	call ANZEIGE_HEIZZEITEN_BARGRAPH_TEMP1_2
	LDS temp1,(adr_MOMENTAN_ON2)
	LDS temp2,(adr_MOMENTAN_OFF2)
	call ANZEIGE_HEIZZEITEN_BARGRAPH_TEMP1_2
	LDS temp1,(adr_MOMENTAN_ON3)
	LDS temp2,(adr_MOMENTAN_OFF3)
	call ANZEIGE_HEIZZEITEN_BARGRAPH_TEMP1_2
;-------------------------------------------------------------------------------
; aktuelle Stunde																
	LDS temp1,(adr_hh)
	LDS temp,(adr_ss)
	andi temp,0b00000001
	tst temp
	breq PC+2
	rcall BARGRAPH_PUNKT_SET_TEMP1	
	LDS temp1,(adr_hh)
	LDS temp,(adr_ss)
	andi temp,0b00000001
	tst temp
	brne PC+2
	rcall BARGRAPH_PUNKT_CLEAR_TEMP1	
ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
ANZEIGE_HEIZZEITEN_BARGRAPH_TEMP1_2:
	cpi temp1,255
	breq ANZEIGE_HEIZZEITEN_ERROR
	cpi temp2,255
	breq ANZEIGE_HEIZZEITEN_ERROR
	rjmp ANZEIGE_HEIZZEITEN_RUN
;-------------------------------------------------------------------------------
ANZEIGE_HEIZZEITEN_ERROR:
	ret
;-------------------------------------------------------------------------------
ANZEIGE_HEIZZEITEN_RUN:
	push temp2
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	mov temp8,temp1	; Anfang	
	POP temp1 		; (temp2)		
	call FUNKTION_ZEIT_DECODIEREN_TEMP1_2	; temp1=hh temp2=mm
	mov temp9,temp1	; Ende		
ANZEIGE_HEIZZEITEN_s:
	mov temp1,temp8
	call BARGRAPH_PUNKT_SET_TEMP1
	cp temp8,temp9
	brne PC+2
	ret	; zurck
	inc temp8
	rjmp ANZEIGE_HEIZZEITEN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
