; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	STS(adr_TASTE_OLD),temp
	tst temp
	brne MENUE_START
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
; Langer oder kurzer Tastendruck												
MENUE_START:
	ldi temp9,100
MENUE_s:
	call TASTATUR_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_TASTE_KURZ
	call WAIT_10ms
	dec temp9
	brne MENUE_s
;-------------------------------------------------------------------------------
MENUE_TASTE_LANG:
	call TEXT_MINUS
	call BARGRAPH_LAUFBAND
	LDS temp,(adr_TASTE)
	STS(adr_TASTE),NULL				; NULL	
	cpi temp,(TASTE_AM_WERT)		; Taste A/M			
	breq MENUE_TASTE_LANG_AM
	cpi temp,(TASTE_PROG_WERT)		; TASTE PROG
	breq MENUE_TASTE_LANG_PROG
	cpi temp,(TASTE_TEMPERATUR_WERT); TASTE TEMPERATUR	
	breq MENUE_TASTE_LANG_TEMPERATUR
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_TASTE_LANG_AM:
	ldi temp,1
	STS(adr_MENUE),temp
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_TASTE_LANG_PROG:
	ldi temp,20
	STS(adr_MENUE),temp
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_TASTE_LANG_TEMPERATUR:
	ldi temp,50
	STS(adr_MENUE),temp
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_TASTE_KURZ:
	LDS temp,(adr_TASTE_OLD)
	STS(adr_TASTE),NULL				; NULL	
	cpi temp,(TASTE_AM_WERT)		; Taste A/M			
	breq MENUE_TASTE_AM
	cpi temp,(TASTE_PROG_WERT)		; TASTE PROG
	breq MENUE_TASTE_PROG
	cpi temp,(TASTE_TEMPERATUR_WERT); TASTE TEMPERATUR	
	breq MENUE_TASTE_TEMPERATUR
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_TASTE_AM:
	LDS temp,(adr_MODUS_MANU_ON)
	inc temp
	andi temp,0b00000001
	STS(adr_MODUS_MANU_ON),temp
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_TASTE_PROG:
	ldi temp,60
	STS(adr_MENUE),temp
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_TASTE_TEMPERATUR:
	ldi temp,10
	STS(adr_MENUE),temp
	jmp MENUE_RUN
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z		
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	LSL temp	; x2, wegen "jmp (2 Words)"	
	add ZL,temp
	adc ZH,NULL
	IJMP	; SPRUNG nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	jmp MENUE_EDIT_TEMPERATUR_SOLL	; Hauptmenue
	jmp MENUE_RESERVE_0
	jmp MENUE_RESERVE_1
	jmp EEPROM_KONFIGURATION_SPEICHERN
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
;-------------------------------------------------------------------------------
	jmp MENUE_EDIT_TEMPERATUR_TAG				;10
	jmp MENUE_EDIT_TEMPERATUR_NACHT
	jmp EEPROM_KONFIGURATION_SPEICHERN
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
;-------------------------------------------------------------------------------
	jmp MENUE_ANZEIGE_TEMPERATUR_IST_TEXT		; 20
	jmp MENUE_ANZEIGE_TEMPERATUR_IST
	jmp MENUE_ANZEIGE_BATTERIESPANNUNG_TEXT
	jmp MENUE_ANZEIGE_BATTERIESPANNUNG
	jmp MENUE_ANZEIGE_MOTOR_POSITION_TEXT
	jmp MENUE_ANZEIGE_MOTOR_POSITION
	jmp MENUE_ANZEIGE_MOTOR_POSITION_ENDANSCHLAG_TEXT
	jmp MENUE_ANZEIGE_MOTOR_POSITION_ENDANSCHLAG
	jmp MENUE_ANZEIGE_ZEIT_HH_MM
	jmp MENUE_ANZEIGE_ZEIT_SS
	jmp MENUE_EDIT_WOCHENTAG
	jmp MENUE_EDIT_SS
	jmp MENUE_EDIT_HH
	jmp MENUE_EDIT_MM
	jmp MENUE_EDIT_OFFSET_TEXT
	jmp MENUE_EDIT_OFFSET
	jmp MENUE_ANZEIGE_ADC_TEXT
	jmp MENUE_ANZEIGE_ADC
	jmp MENUE_ANZEIGE_CAL_TEXT
	jmp MENUE_ANZEIGE_INST_TEXT
;-------------------------------------------------------------------------------
	jmp EEPROM_KONFIGURATION_SPEICHERN		; 40
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
;-------------------------------------------------------------------------------
	jmp MENUE_BOOST						; 50
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
;-------------------------------------------------------------------------------
	jmp MENUE_EDIT_ZEITPROGRAMM_GRUPPE	; 60
	jmp MENUE_EDIT_ZEITPROGRAMM_1ON
	jmp MENUE_EDIT_ZEITPROGRAMM_1OFF
	jmp MENUE_EDIT_ZEITPROGRAMM_2ON
	jmp MENUE_EDIT_ZEITPROGRAMM_2OFF
	jmp MENUE_EDIT_ZEITPROGRAMM_3ON
	jmp MENUE_EDIT_ZEITPROGRAMM_3OFF
	jmp EEPROM_KONFIGURATION_SPEICHERN
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
;-------------------------------------------------------------------------------
	jmp MENUE_DUMMY						; 70
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
;-------------------------------------------------------------------------------
	jmp MENUE_DUMMY						; 80
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp MENUE_DUMMY
	jmp EEPROM_KONFIGURATION_SPEICHERN
	; Fehlerprfung
	nop
	nop
	STS (adr_MENUE),NULL
	jmp MENUE_RUN
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_DUMMY:
	call LCD_CLEAR
	call WAIT_200ms
	ldi temp4,(LCD_d)
	ldi temp3,(LCD_u_)
	STS(adr_LCD3),temp4
	STS(adr_LCD2),temp3
	LDS temp1,(adr_MENUE)
	call LCD_ZAHL_2_TEMP1
	call WAIT_200ms
	rjmp MENUE_DUMMY
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_PLUS_EINS:
	call LCD_CLEAR
	call TASTATUR_ABFRAGE_WAIT_NULL
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_RESERVE_0:
	call TEXT_RES0
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_RESERVE_0
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_RESERVE_1:
	call TEXT_RES1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_RESERVE_1
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Hauptmenue !!!!!																
MENUE_EDIT_TEMPERATUR_SOLL:
;	call MOTOR_POSITION_LADEN_TEMP1_2
;	call LCD_ZAHL_TEMP1_2	
;	ret						

	; Anzeige "AUTO" / "MANU"	
	LDS temp,(adr_MODUS_MANU_ON)
	tst temp
	brne PC+2
	call LCD_AUTO_ON
	LDS temp,(adr_MODUS_MANU_ON)
	tst temp
	breq PC+2
	call LCD_MANU_ON
;-------------------------------------------------------------------------------
	call ANZEIGE_BARGRAPH_HEIZZEITEN
;-------------------------------------------------------------------------------
	LDS temp1,(adr_TEMPERATUR_SOLL_L)
	LDS temp2,(adr_TEMPERATUR_SOLL_H)
	call DREHGEBER_STEP5_TEMP1_2	; STEP=5	
	STS(adr_TEMPERATUR_SOLL_L),temp1
	STS(adr_TEMPERATUR_SOLL_H),temp2
	jmp LCD_TEMPERATUR_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "IST"																			
MENUE_ANZEIGE_TEMPERATUR_IST_TEXT:
	call TEXT_IST
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_TEMPERATUR_IST_TEXT
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_TEMPERATUR_IST:
	call ADC_MESSEN_0
	LDS temp1,(adr_TEMPERATUR_IST_L)
	LDS temp2,(adr_TEMPERATUR_IST_H)
	call LCD_TEMPERATUR_TEMP1_2
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_TEMPERATUR_IST
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "BATT"																		
MENUE_ANZEIGE_BATTERIESPANNUNG_TEXT:
	call TEXT_BATT
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_BATTERIESPANNUNG_TEXT
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; U(VBG) x 1023 : ADC(VBG)														
MENUE_ANZEIGE_BATTERIESPANNUNG:
	LDS temp,(adr_ss)
	cpi temp,30
	brsh MENUE_ANZEIGE_BATT_OHNE_LAST
	call MOTOR_BEEP			; 30 sec Last
MENUE_ANZEIGE_BATT_OHNE_LAST:
	call LCD_PUNKT_UNTEN_ON
	call ADC_MESSEN_VBG
	ldi temp1,LOW (U_VBG)
	ldi temp2,HIGH(U_VBG)
	ldi temp3,LOW (1023)
	ldi temp4,HIGH(1023)
	call FUNKTION_MULTIPLIKATION_16_16_32

	LDS temp5,(adr_ADC_VBG_L)
	LDS temp6,(adr_ADC_VBG_H)
	call FUNKTION_DIVISION_32_16
	call LCD_ZAHL_TEMP1_2
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_BATTERIESPANNUNG
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "POS"																			
MENUE_ANZEIGE_MOTOR_POSITION_TEXT:
	call TEXT_POS
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_MOTOR_POSITION_TEXT
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_MOTOR_POSITION:
	call MOTOR_POSITION_LADEN_TEMP1_2
	call LCD_ZAHL_TEMP1_2
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_MOTOR_POSITION
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "POSE"																		
MENUE_ANZEIGE_MOTOR_POSITION_ENDANSCHLAG_TEXT:
	call TEXT_POSE
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_MOTOR_POSITION_ENDANSCHLAG_TEXT
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_MOTOR_POSITION_ENDANSCHLAG:
	LDS temp1,(adr_MOTOR_POSITION_ENDE_L)
	LDS temp2,(adr_MOTOR_POSITION_ENDE_H)
	call LCD_ZAHL_TEMP1_2
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_MOTOR_POSITION_ENDANSCHLAG
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_OFFSET_TEXT:
	call TEXT_OFFS
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_OFFSET_TEXT
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_OFFSET:
	call LCD_PROG_ON
	LDS temp1,(adr_TEMPERATUR_IST_OFFSET)
	call DREHGEBER_TEMP1_2
	STS(adr_TEMPERATUR_IST_OFFSET),temp1
	call LCD_ZAHL_NEG_TEMP1	; signiert
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_OFFSET
jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "ADC"																			
MENUE_ANZEIGE_ADC_TEXT:
	call TEXT_ADC
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_ADC_TEXT
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_ADC:
	call LCD_BARGRAPH_ON
	call ADC_MESSEN_0
	call LCD_BARGRAPH_OFF

	LDS temp1,(adr_ADC_0_L)
	LDS temp2,(adr_ADC_0_H)
	call LCD_ZAHL_TEMP1_2
	call WAIT_50ms

	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_ADC
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "CAL"																			
MENUE_ANZEIGE_CAL_TEXT:
	call TEXT_CAL
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_CAL_TEXT
	cpi temp,(TASTE_TEMPERATUR_WERT) ; TASTE "TEMP"
	breq MENUE_ANZEIGE_CAL_RUN
	jmp MENUE_PLUS_EINS
;-------------------------------------------------------------------------------
MENUE_ANZEIGE_CAL_RUN:
	jmp MOTOR_CALIBRIERUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "INST"																		
MENUE_ANZEIGE_INST_TEXT:
	call TEXT_INST
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_INST_TEXT
	cpi temp,(TASTE_TEMPERATUR_WERT) ; TASTE "TEMP"
	breq MENUE_ANZEIGE_INST_RUN
	jmp MENUE_PLUS_EINS
;-------------------------------------------------------------------------------
MENUE_ANZEIGE_INST_RUN:
	call MOTOR_AUF
	call MOTOR_WAIT
	STS(adr_MENUE),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BOOST:
	call TEXT_BOOST
	call WAIT_2s
	ldi temp1,100
MENUE_BOOST_s:
	push temp1
	call LCD_ZAHL_TEMP1
	pop temp1
	call WAIT_100ms
	dec temp1
	brne MENUE_BOOST_s

	STS(adr_MENUE),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_TEMPERATUR_TAG:
	call LCD_SONNE_ON
	call LCD_PROG_ON
	LDS temp1,(adr_TEMPERATUR_TAG_L)
	LDS temp2,(adr_TEMPERATUR_TAG_H)
	call DREHGEBER_STEP5_TEMP1_2	; STEP=5	
	STS(adr_TEMPERATUR_TAG_L),temp1
	STS(adr_TEMPERATUR_TAG_H),temp2
	call LCD_TEMPERATUR_TEMP1_2
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_TEMPERATUR_TAG
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_TEMPERATUR_NACHT:
	call LCD_MOND_ON
	call LCD_PROG_ON
	LDS temp1,(adr_TEMPERATUR_NACHT_L)
	LDS temp2,(adr_TEMPERATUR_NACHT_H)
	call DREHGEBER_STEP5_TEMP1_2	; STEP=5	
	STS(adr_TEMPERATUR_NACHT_L),temp1
	STS(adr_TEMPERATUR_NACHT_H),temp2
	call LCD_TEMPERATUR_TEMP1_2
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_TEMPERATUR_NACHT
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_ZEIT_HH_MM:
	call LCD_DOPPELPUNKT_BLINKEN
	LDS temp1,(adr_mm)
	clr temp2
	call FUNKTION_HEX_ASCII_TEMP1_2
	mov temp,temp1
	call LCD_UMWANDLUNG_TEMP
	STS(adr_LCD0),temp
	mov temp,temp2
	call LCD_UMWANDLUNG_TEMP
	STS(adr_LCD1),temp

	LDS temp1,(adr_hh)
	clr temp2
	call FUNKTION_HEX_ASCII_TEMP1_2
	mov temp,temp1
	call LCD_UMWANDLUNG_TEMP
	STS(adr_LCD2),temp
	mov temp,temp2
	call LCD_UMWANDLUNG_TEMP
	STS(adr_LCD3),temp
	call LCD_ZIFFERN_WRITE

	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_ZEIT_HH_MM
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ANZEIGE_ZEIT_SS:
	call LCD_DOPPELPUNKT_ON
	ldi temp,(LCD_)
	STS(adr_LCD2),temp
	STS(adr_LCD3),temp

	LDS temp1,(adr_ss)
	clr temp2
	call FUNKTION_HEX_ASCII_TEMP1_2
	mov temp,temp1
	call LCD_UMWANDLUNG_TEMP
	STS(adr_LCD0),temp
	mov temp,temp2
	call LCD_UMWANDLUNG_TEMP
	STS(adr_LCD1),temp
	call LCD_ZIFFERN_WRITE
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_ANZEIGE_ZEIT_SS
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_WOCHENTAG:
	call LCD_PROG_ON
	call LCD_DOPPELPUNKT_ON
	ldi temp3,(LCD_d)
	ldi temp2,(LCD_d)
	ldi temp1,(LCD_)
	STS(adr_LCD3),temp3
	STS(adr_LCD2),temp2
	STS(adr_LCD1),temp1

	LDS temp1,(adr_WOCHENTAG)
	call DREHGEBER_TEMP1_2
	cpi temp1,7+1	; 1...7
	brlo PC+2
	ldi temp1,7
	cpi temp1,0		
	brne PC+2
	ldi temp1,1
	STS(adr_WOCHENTAG),temp1
	call LCD_ZAHL_1_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_WOCHENTAG
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_HH:
	call LCD_PROG_ON
	ldi temp,(LCD_H)
	STS(adr_LCD2),temp
	STS(adr_LCD3),temp
	call LCD_DOPPELPUNKT_ON
	LDS temp1,(adr_hh)
	call DREHGEBER_TEMP1_2
	cpi temp1,255	; 0..23
	brne PC+2
	ldi temp1,23
	cpi temp1,23+1
	brlo PC+2
	clr temp1
	STS(adr_hh),temp1
	call LCD_ZAHL_2_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_HH
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_MM:
	call LCD_PROG_ON
	call TASTATUR_ABFRAGE
	ldi temp,(LCD_M)
	STS(adr_LCD2),temp
	STS(adr_LCD3),temp
	call LCD_DOPPELPUNKT_ON
	LDS temp1,(adr_mm)
	call DREHGEBER_TEMP1_2
	cpi temp1,255	; 0..59
	brne PC+2
	ldi temp1,59
	cpi temp1,59+1
	brlo PC+2
	clr temp1
	STS(adr_mm),temp1
	call LCD_ZAHL_2_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_MM
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_SS:
	call LCD_PROG_ON
	ldi temp,(LCD_)
	STS(adr_LCD2),temp
	STS(adr_LCD3),temp
	call LCD_DOPPELPUNKT_ON
	LDS temp1,(adr_ss)
	call DREHGEBER_TEMP1_2
	cpi temp1,255	; 0..59
	brne PC+2
	ldi temp1,59
	cpi temp1,59+1
	brlo PC+2
	clr temp1
	STS(adr_ss),temp1
	call LCD_ZAHL_2_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_SS
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; 0= 1-7	Mo-So																
; 1= 1		Mo																	
; 2= 2		Di																	
; 3= 3		Mi																	
; 4= 4		Do																	
; 5= 5		Fr																	
; 6= 6		Sa																	
; 7= 7		So																	
; 8=1-5		Mo-Fr																
; 9=6-7		Sa-So																
;																				
MENUE_EDIT_ZEITPROGRAMM_GRUPPE:
	call LCD_CLEAR
	call LCD_PROG_ON
	LDS temp,(adr_WOCHENTAG)
	STS(adr_ZEITPROGRAMM_GRUPPE),temp
MENUE_EDIT_ZEITPROGRAMM_GRUPPE_s:
	LDS temp1,(adr_ZEITPROGRAMM_GRUPPE)
	call DREHGEBER_TEMP1_2
	cpi temp1,9+1	; 0...9
	brlo PC+2
	clr temp1
	STS(adr_ZEITPROGRAMM_GRUPPE),temp1
	call ANZEIGE_TEXT_ZEITPROGRAMM_GRUPPE
;-------------------------------------------------------------------------------
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	LDS temp1,(adr_ZEITPROGRAMM_GRUPPE)
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_0:
	cpi temp1,0
	brne MENUE_EDIT_ZEITPROGRAMM_1
	ldi ZL,LOW (adr_TAG1_ON1) 
	ldi ZH,HIGH(adr_TAG1_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_1:
	cpi temp1,1
	brne MENUE_EDIT_ZEITPROGRAMM_2
	ldi ZL,LOW (adr_TAG1_ON1)
	ldi ZH,HIGH(adr_TAG1_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_2:
	cpi temp1,2
	brne MENUE_EDIT_ZEITPROGRAMM_3
	ldi ZL,LOW (adr_TAG2_ON1)
	ldi ZH,HIGH(adr_TAG2_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_3:
	cpi temp1,3
	brne MENUE_EDIT_ZEITPROGRAMM_4
	ldi ZL,LOW (adr_TAG3_ON1)
	ldi ZH,HIGH(adr_TAG3_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_4:
	cpi temp1,4
	brne MENUE_EDIT_ZEITPROGRAMM_5
	ldi ZL,LOW (adr_TAG4_ON1)
	ldi ZH,HIGH(adr_TAG4_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_5:
	cpi temp1,5
	brne MENUE_EDIT_ZEITPROGRAMM_6
	ldi ZL,LOW (adr_TAG5_ON1)
	ldi ZH,HIGH(adr_TAG5_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_6:
	cpi temp1,6
	brne MENUE_EDIT_ZEITPROGRAMM_7
	ldi ZL,LOW (adr_TAG6_ON1)
	ldi ZH,HIGH(adr_TAG6_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_7:
	cpi temp1,7
	brne MENUE_EDIT_ZEITPROGRAMM_8
	ldi ZL,LOW (adr_TAG7_ON1)
	ldi ZH,HIGH(adr_TAG7_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_8:
	cpi temp1,8
	brne MENUE_EDIT_ZEITPROGRAMM_9
	ldi ZL,LOW (adr_TAG1_ON1)
	ldi ZH,HIGH(adr_TAG1_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_9:
	ldi ZL,LOW (adr_TAG6_ON1)
	ldi ZH,HIGH(adr_TAG6_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_FERTIG:
	LD temp,Z+
	ST X+,temp
	LD temp,Z+
	ST X+,temp
	LD temp,Z+
	ST X+,temp
	LD temp,Z+
	ST X+,temp
	LD temp,Z+
	ST X+,temp
	LD temp,Z+
	ST X+,temp
;-------------------------------------------------------------------------------
	call ANZEIGE_BARGRAPH_HEIZZEITEN
	call TASTATUR_ABFRAGE
	tst temp
	brne MENUE_EDIT_ZEITPROGRAMM_ENDE
	jmp MENUE_EDIT_ZEITPROGRAMM_GRUPPE_s	; Schleife
MENUE_EDIT_ZEITPROGRAMM_ENDE:
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Schaltpunkt 1-ON																
MENUE_EDIT_ZEITPROGRAMM_1ON:
	call LCD_PROG_ON
	call LCD_SONNE_ON
;-------------------------------------------------------------------------------
	LDS temp1,(adr_MOMENTAN_ON1)
	call DREHGEBER_TEMP1_2			; Drehgeber	
	call FUNCTION_ZEIT_CHECK_TEMP1	; Check		
	STS(adr_MOMENTAN_ON1),temp1	
;-------------------------------------------------------------------------------
	call ANZEIGE_ZEIT_SCHALTPUNKT_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_ZEITPROGRAMM_1ON
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Schaltpunkt 1-OFF																
MENUE_EDIT_ZEITPROGRAMM_1OFF:
	LDS temp,(adr_MOMENTAN_OFF1)
	cpi temp,255
	brne MENUE_EDIT_ZEITPROGRAMM_1OFF_RUN
	LDS temp,(adr_MOMENTAN_ON1)
	STS(adr_MOMENTAN_OFF1),temp
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_1OFF_RUN:
	call LCD_PROG_ON
	call LCD_MOND_ON
;-------------------------------------------------------------------------------
	LDS temp1,(adr_MOMENTAN_OFF1)
	call DREHGEBER_TEMP1_2			; Drehgeber	
	call FUNCTION_ZEIT_CHECK_TEMP1	; Check		
	STS(adr_MOMENTAN_OFF1),temp1
;-------------------------------------------------------------------------------
	call ANZEIGE_ZEIT_SCHALTPUNKT_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_ZEITPROGRAMM_1OFF_RUN
;-------------------------------------------------------------------------------
; Ausschaltzeit definiert ?														
	LDS temp,(adr_MOMENTAN_OFF1)
	cpi temp,255
	brne MENUE_EDIT_ZEITPROGRAMM_1OFF_FERTIG
	STS(adr_MOMENTAN_ON1),VOLL
	call TEXT_ERROR
MENUE_EDIT_ZEITPROGRAMM_1OFF_FERTIG:
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Schaltpunkt 2-ON																
MENUE_EDIT_ZEITPROGRAMM_2ON:
	call LCD_PROG_ON
	call LCD_SONNE_ON
;-------------------------------------------------------------------------------
	LDS temp1,(adr_MOMENTAN_ON2)
	call DREHGEBER_TEMP1_2			; Drehgeber	
	call FUNCTION_ZEIT_CHECK_TEMP1	; Check		
	STS(adr_MOMENTAN_ON2),temp1
;-------------------------------------------------------------------------------
	call ANZEIGE_ZEIT_SCHALTPUNKT_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_ZEITPROGRAMM_2ON
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Schaltpunkt 2-OFF																
MENUE_EDIT_ZEITPROGRAMM_2OFF:
	call LCD_PROG_ON
	call LCD_MOND_ON
;-------------------------------------------------------------------------------
	LDS temp1,(adr_MOMENTAN_OFF2)
	call DREHGEBER_TEMP1_2			; Drehgeber	
	call FUNCTION_ZEIT_CHECK_TEMP1	; Check		
	STS(adr_MOMENTAN_OFF2),temp1
;-------------------------------------------------------------------------------
	call ANZEIGE_ZEIT_SCHALTPUNKT_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_ZEITPROGRAMM_2OFF
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Schaltpunkt 3-ON																
MENUE_EDIT_ZEITPROGRAMM_3ON:
	call LCD_PROG_ON
	call LCD_SONNE_ON
;-------------------------------------------------------------------------------
	LDS temp1,(adr_MOMENTAN_ON3)
	call DREHGEBER_TEMP1_2			; Drehgeber	
	call FUNCTION_ZEIT_CHECK_TEMP1	; Check		
	STS(adr_MOMENTAN_ON3),temp1
;-------------------------------------------------------------------------------
	call ANZEIGE_ZEIT_SCHALTPUNKT_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_ZEITPROGRAMM_3ON
	jmp MENUE_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Schaltpunkt 3-OFF																
MENUE_EDIT_ZEITPROGRAMM_3OFF:
	call LCD_PROG_ON
	call LCD_MOND_ON
;-------------------------------------------------------------------------------
	LDS temp1,(adr_MOMENTAN_OFF3)
	call DREHGEBER_TEMP1_2			; Drehgeber	
	call FUNCTION_ZEIT_CHECK_TEMP1	; Check		
	STS(adr_MOMENTAN_OFF3),temp1
;-------------------------------------------------------------------------------
	call ANZEIGE_ZEIT_SCHALTPUNKT_TEMP1
	call TASTATUR_ABFRAGE
	tst temp
	breq MENUE_EDIT_ZEITPROGRAMM_3OFF
;-------------------------------------------------------------------------------
MENUE_EDIT_SAVE:
	LDS temp1,(adr_ZEITPROGRAMM_GRUPPE)
MENUE_EDIT_SAVE_0:
	cpi temp1,0
	brne MENUE_EDIT_SAVE_1
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_1
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_2
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_3
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_4
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_5
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_6
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_7
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_1:
	cpi temp1,1
	brne MENUE_EDIT_SAVE_2
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_1
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_2:
	cpi temp1,2
	brne MENUE_EDIT_SAVE_3
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_2
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_3:
	cpi temp1,3
	brne MENUE_EDIT_SAVE_4
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_3
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_4:
	cpi temp1,4
	brne MENUE_EDIT_SAVE_5
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_4
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_5:
	cpi temp1,5
	brne MENUE_EDIT_SAVE_6
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_5
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_6:
	cpi temp1,6
	brne MENUE_EDIT_SAVE_7
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_6
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_7:
	cpi temp1,7
	brne MENUE_EDIT_SAVE_8
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_7
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_8:
	cpi temp1,8
	brne MENUE_EDIT_SAVE_9
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_1
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_2
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_3
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_4
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_5
	jmp MENUE_PLUS_EINS
MENUE_EDIT_SAVE_9:
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_6
	call MENUE_EDIT_ZEITPROGRAMM_SAVE_7
	jmp MENUE_PLUS_EINS
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_1:
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	ldi ZL,LOW (adr_TAG1_ON1)
	ldi ZH,HIGH(adr_TAG1_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_SAVE_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_2:
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	ldi ZL,LOW (adr_TAG2_ON1)
	ldi ZH,HIGH(adr_TAG2_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_SAVE_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_3:
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	ldi ZL,LOW (adr_TAG3_ON1)
	ldi ZH,HIGH(adr_TAG3_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_SAVE_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_4:
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	ldi ZL,LOW (adr_TAG4_ON1)
	ldi ZH,HIGH(adr_TAG4_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_SAVE_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_5:
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	ldi ZL,LOW (adr_TAG5_ON1)
	ldi ZH,HIGH(adr_TAG5_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_SAVE_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_6:
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	ldi ZL,LOW (adr_TAG6_ON1)
	ldi ZH,HIGH(adr_TAG6_ON1)
	jmp MENUE_EDIT_ZEITPROGRAMM_SAVE_FERTIG
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_7:
	ldi XL,LOW (adr_MOMENTAN_ON1)
	ldi XH,HIGH(adr_MOMENTAN_ON1)
	ldi ZL,LOW (adr_TAG7_ON1)
	ldi ZH,HIGH(adr_TAG7_ON1)
;-------------------------------------------------------------------------------
MENUE_EDIT_ZEITPROGRAMM_SAVE_FERTIG:
	LD temp,X+
	ST Z+,temp
	LD temp,X+
	ST Z+,temp
	LD temp,X+
	ST Z+,temp
	LD temp,X+
	ST Z+,temp
	LD temp,X+
	ST Z+,temp
	LD temp,X+
	ST Z+,temp
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################






